config/routes.rb
# frozen_string_literal: true

require 'avalon/routing/can_constraint'

Rails.application.routes.draw do
  mount Samvera::Persona::Engine => '/'
  mount Blacklight::Engine => '/catalog'
  concern :searchable, Blacklight::Routes::Searchable.new
  concern :exportable, Blacklight::Routes::Exportable.new

  resource :catalog, only: [:index], as: 'catalog', path: '/catalog', controller: 'catalog' do
    concerns :searchable
  end

  # For some reason this needs to be after `resource :catalog` otherwise Blacklight will generate links to / instead of /catalog
  root to: "catalog#index"

  get '/mejs/:version', to: 'application#mejs'

  resources :solr_documents, only: [:show], path: '/catalog', controller: 'catalog' do
    concerns :exportable
  end

  resources :encode_records, only: [:show, :index] do
    collection do
      post :paged_index
      post :progress
    end
  end

  resources :checkouts, only: [:index, :create, :show, :update, :destroy], :constraints => lambda { |request| Avalon::Configuration.controlled_digital_lending_enabled? } do
    collection do
      patch :return_all
    end

    member do
      patch :return
    end
  end

  resources :bookmarks do
    concerns :exportable

    collection do
      delete 'clear'
      get 'delete'#, as: :delete_bookmarks
      post 'delete'
      get 'move'#, as: :move_bookmarks
      post 'move'
      get 'update_access_control'#, as: :update_access_control_bookmarks
      post 'update_access_control'
      post 'publish'#, as: :publish_bookmarks
      post 'unpublish'#, as: :unpublish_bookmarks
      get 'add_to_playlist'
      post 'add_to_playlist'
      get 'intercom_push'
      post 'intercom_push'
      get 'merge'
      post 'merge'
      get 'count', constraints: { format: 'json' }
    end
  end

  devise_for :users, controllers: { omniauth_callbacks: 'users/omniauth_callbacks', sessions: 'users/sessions' }
  devise_scope :user do
    Avalon::Authentication::Providers.collect { |provider| provider[:provider] }.uniq.each do |provider_name|
      match "/users/auth/#{provider_name}/callback", to: "users/omniauth_callbacks##{provider_name}", as: "user_omniauth_callback_#{provider_name}".to_sym, via: [:get, :post]
    end
  end

  mount BrowseEverything::Engine => '/browse'

  # Avalon routes
  match "/authorize", to: 'derivatives#authorize', via: [:get, :post]
  match "/authorize/:path", to: 'derivatives#authorize', via: [:get, :post]

  namespace :admin do
    resources :groups, except: [:show] do
      collection do
        put 'update_multiple'
      end
      member do
        put 'update_users'
      end
    end
    resources :collections do
      member do
        get 'edit'
        get 'remove'
        get 'items'
        get 'poster'
        post 'poster', action: :attach_poster, as: 'attach_poster'
        delete 'poster', action: :remove_poster, as: 'remove_poster'
      end
    end

    namespace :migration_report, controller: '/migration_status' do
      get '/', action: :index
      get ':class', action: :show, as: 'by_class'
      get ':id/detail', action: :detail, as: 'detail'
      get ':id/report', action: :report, as: 'report'
    end
  end

  resources :vocabulary, except: [:create, :destroy, :new, :edit]

  resources :collections, only: [:index, :show] do
    member do
      get :poster
    end
  end

  resources :media_objects, except: [:create, :update] do
    member do
      put :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update, action: :json_update, constraints: { format: 'json' }
      patch :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update_status
      get :progress, :action => :show_progress
      get 'content/:file', :action => :deliver_content, :as => :inspect
      get 'track/:part', :action => :show, :as => :indexed_section
      get 'section/:content', :action => :show, :as => :id_section
      get 'section/:content/stream', :action => :show_stream_details, :as => :section_stream
      get 'section/:content/embed', :to => redirect('/master_files/%{content}/embed')
      get 'tree', :action => :tree, :as => :tree
      get :confirm_remove
      post :add_to_playlist
      patch :intercom_push
      get :manifest
      get :move_preview, defaults: { format: 'json' }, constraints: { format: 'json' }
    end
    collection do
      post :create, action: :create, constraints: { format: 'json' }
      post :set_session_quality
      get :confirm_remove
      put :update_status
      # 'delete' has special signifigance so use 'remove' for now
      delete :remove, :action => :destroy
      get :intercom_collections
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit] do
      get :index, constraints: { format: 'json' }, on: :collection
    end
  end

  resources :master_files, except: [:new, :index] do
    member do
      get  'thumbnail', :to => 'master_files#get_frame', :defaults => { :type => 'thumbnail' }
      get  'poster',    :to => 'master_files#get_frame', :defaults => { :type => 'poster' }

      post 'thumbnail', :to => 'master_files#set_frame', :defaults => { :type => 'thumbnail', :format => 'html' }
      post 'poster',    :to => 'master_files#set_frame', :defaults => { :type => 'poster', :format => 'html' }
      post 'still',     :to => 'master_files#set_frame', :defaults => { :format => 'html' }
      get :embed
      post 'attach_structure'
      get :captions
      get :waveform
      match ':quality.m3u8', to: 'master_files#hls_manifest', via: [:get], as: :hls_manifest
      get 'structure', to: 'master_files#structure', constraints: { format: 'json' }
      post 'structure', to: 'master_files#set_structure', constraints: { format: 'json' }
      delete 'structure', to: 'master_files#delete_structure', constraints: { format: 'json' }
      post 'move'
      get 'transcript/:t_id', to: 'master_files#transcript'
      get :search
      
      if Settings.derivative.allow_download
        get :download_derivative
      end
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit] do
      member do
        get 'captions'
        get 'transcripts', :to => redirect('/master_files/%{master_file_id}/supplemental_files/%{id}')
      end
      get :index, constraints: { format: 'json' }, on: :collection
    end
  end

  match "iiif_auth_token/:id", to: 'master_files#iiif_auth_token', via: [:get], as: :iiif_auth_token

  resources :derivatives, only: [:create]
  match "/autocomplete", to: 'objects#autocomplete', via: [:get]
  match "/objects/:id", to: 'objects#show', via: [:get], :as => :objects
  match "/object/:id", to: 'objects#show', via: [:get]

  resources :playlists do
    resources :playlist_items, path: 'items', only: [:create, :update, :show] do
      get 'related_items'
    end
    member do
      patch 'update_multiple'
      delete 'update_multiple'
      patch 'regenerate_access_token'
      get 'refresh_info'
      get 'manifest'
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_playlist'
      end
    end
  end

  resources :avalon_marker, only: [:create, :show, :update, :destroy]

  resources :comments, only: [:index, :create]

  resources :playlist_items, only: [:update], :constraints => {:format => /(js|json)/}

  resources :timelines do
    member do
      patch 'regenerate_access_token'
      post 'manifest', to: 'timelines#manifest_update', constraints: { format: 'json' }
      get 'manifest'
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_timeline'
      end
    end
  end
  get '/timeliner', to: 'timelines#timeliner', as: :timeliner

  resources :dropbox, :only => [] do
    collection do
      delete :bulk_delete
    end
  end

  match "/oembed", to: 'master_files#oembed', via: [:get]

  constraints(Avalon::Routing::CanConstraint.new(:read, :about_page)) do
    mount AboutPage::Engine => '/about(.:format)', as: 'about_page'
  end
  get '/about(.:format)', to: redirect('/')
  get '/about/health.yaml', to: 'about_page/about#health', defaults: { :format => 'yaml' }
  get '/about/health(.:format)', to: redirect('/')

  constraints(Avalon::Routing::CanConstraint.new(:manage, :jobs)) do
    mount Sidekiq::Web, at: '/jobs', as: 'jobs'
  end
  get '/jobs(.:format)', to: redirect('/')

  scope :persona, as: 'persona' do
    resources :users, only: [:paged_index], controller: 'samvera/persona/users' do
      collection do
        post 'paged_index'
      end
    end
  end
end

app/controllers/collections_controller.rb
# Copyright 2011-2024, The Trustees of Indiana University and Northwestern
#   University.  Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
# 
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software distributed
#   under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
#   CONDITIONS OF ANY KIND, either express or implied. See the License for the
#   specific language governing permissions and limitations under the License.
# ---  END LICENSE_HEADER BLOCK  ---

class CollectionsController < CatalogController
  skip_before_action :enforce_show_permissions, only: :show

  def index
    response = blacklight_config.repository.search(CollectionSearchBuilder.new(self))
    collections = response.documents
    if (params[:only] == 'carousel')
      collections = collections.select { |doc| Settings.home_page&.carousel_collections&.include? doc.id }
    end
    if params[:limit].present?
      collections = collections.sample(params[:limit].to_i)
    end
    @doc_presenters = collections.collect { |doc| CollectionPresenter.new(doc, view_context) }

    respond_to do |format|
      format.html
      format.json { render json: @doc_presenters }
    end
  end

  def show
    response = blacklight_config.repository.search(CollectionSearchBuilder.new(self))
    document = response.documents.find { |doc| doc.id == params[:id] }
    # Only go on if params[:id] is in @response.documents
    raise CanCan::AccessDenied unless document
    @doc_presenter = CollectionPresenter.new(document, view_context)

    respond_to do |format|
      format.html
      format.json { render json: @doc_presenter }
    end
  end

  def poster
    response = blacklight_config.repository.search(CollectionSearchBuilder.new(self))
    document = response.documents.find { |doc| doc.id == params[:id] }
    # Only go on if params[:id] is in @response.documents
    raise CanCan::AccessDenied unless document

    @collection = SpeedyAF::Proxy::Admin::Collection.find(params['id'])

    file = @collection.poster
    if file.nil? || file.empty?
      render plain: 'Collection Poster Not Found', status: :not_found
    else
      render plain: file.content, content_type: file.mime_type
    end
  end
end

app/views/admin/collections/_apply_special_access.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<div id="access_control_modal" class="modal fade">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
          <div class="modal-header">
              <h4 class='modal-title'><%= modal_title %></h4>
              <button type="button" class="close" data-dismiss="modal">
                <span aria-hidden="true">&times;</span>
                <span class="sr-only">Close</span>
              </button>
          </div>
          <div class="modal-body">
            <p>Would you like to keep all existing Special access entries on items (users, groups, IP addresses)?</p>
            <p>This action will affect <%= affected %> items.</p>
            <div class="form-group">
              <div class="form-check">
                <label>
                  <%= radio_button_tag :overwrite, 'false', true %>
                  Yes, add to existing Special Access entries
                </label>
              </div>
              <div class="form-check">
                <label>
                  <%= radio_button_tag :overwrite, 'true', false %>
                  No, replace existing Special Access entries
                </label>
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <a href="#" data-dismiss="modal" aria-hidden="true" class="btn btn-outline">Cancel</a>
            <%= submit_tag "Apply", name: "apply_to_existing", class: "btn btn-primary", form: 'special_access_form' %>
          </div>
        </div>
    </div>
</div>

app/views/admin/collections/index.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>

<% unless Avalon::ControlledVocabulary.vocabulary[:units] %>
  <% raise Avalon::VocabularyNotFound.new "Units vocabulary not found." %>
<% end %>

<% @page_title = t('collections.title', :application_name => application_name) %>

<% unless @collections.empty? %>
  <div class="row display-flex page-title-wrapper">
    <div class="col-xs-6">
      <h1 class="page-title">My Collections</h1>
    </div>
    <div class="col-xs-6 collection-btn">
      <%= link_to('<span class="btn btn-primary btn-large">Create Collection</span>'.html_safe, new_admin_collection_path) unless cannot? :create, Admin::Collection %>
    </div>
  </div>

  <table class='table table-striped table-responsive' id='admin-collections-table'>
    <thead>
      <tr>
        <th>Title</th>
        <th>Items</th>
        <th>Managers</th>
        <th>Description</th>
        <th></th>
      </tr>
    </thead>
    <tbody>
      <% @collections.to_a.each do |collection| %>
      <tr>
        <td> <strong><%= link_to collection.name, admin_collection_path(collection.id) %></strong> </td>
        <td>
          <%= link_to(pluralize(collection.media_object_count, 'item'), search_catalog_path('f[collection_ssim][]' => collection.name)) %>
          <% if collection.unpublished_media_object_count > 0 %>
          <%=link_to("(#{collection.unpublished_media_object_count} unpublished)", search_catalog_path('f[collection_ssim][]' => collection.name, 'f[workflow_published_sim][]' => "Unpublished")) %>
          <% end %>
        </td>
        <td> <%= pluralize(collection.manager_count, 'manager') %> </td>
        <td> <%= collection.description&.truncate(100, separator: ' ') %> </td>
        <td class="text-right">
          <% if can?(:destroy, collection) %>
          <div class="btn-group">
            <%= link_to('Delete', remove_admin_collection_path(collection.id), class: 'btn btn-danger btn-sm')%>
          </div>
          <% else %>
          &nbsp;
          <% end %>
        </td>
      </tr>
      <% end %>
    </tbody>
  </table>

<% else %>
  <div class="hero-unit">
    <h2>You don't have any collections yet</h2>

    <% if can? :create, Admin::Collection %>
    <p>Would you like to create one?</p>
    <div class="whitespace"></div>
    <p>
      <%= link_to('<span class="btn btn-primary btn-large">Create Collection</span>'.html_safe, new_admin_collection_path) %>
    </p>
    <% else %>
    <p>You'll need to be assigned to one</p>
    <% end %>

  </div>
<% end %>



<% @collection = Admin::Collection.new %>

app/views/admin/collections/new.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<div class="page-title-wrapper">
  <h1 class="page-title">New collection</h1>
</div>
<%= bootstrap_form_for @collection, action: 'create' do |f| %>
  <%= f.text_field :name %>
  <% if @collection.new_record? || can?(:update_unit, @collection)%>
    <%= f.select(:unit, Admin::Collection.units, {}, {:class => 'form-control'}) %>
  <% end %>
  <%= f.text_area :description, rows: 3  %>
  <%= f.text_field :contact_email %>
  <%= f.text_field :website_url %>
  <%= f.text_field :website_label %>
  <a href="/admin/collections" aria-hidden="true" class="btn btn-outline">Cancel</a>
  <%= f.submit class: 'btn btn-primary' %>
<% end %>

app/views/admin/collections/remove.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% content_for :page_scripts do %>
<%= javascript_include_tag 'select2.min' %>
<%= stylesheet_link_tag 'select2.min' %>
<script type="text/javascript">
  $('#target_collection_id').select2();
</script>
<% end %>

<div class="row" style="padding-top: 3rem;">
  <div class="col-md-8 offset-2">
    <%
    item_count = "#{@objects.count} #{'item'.pluralize(@objects.count)}"
    content_pronoun = @objects.count > 1 ? 'them' : 'it'
    %>

    <% if @collection.dropbox_object_count > 0 %>
      <div class="alert alert-warning">
        <span class="fa fa-warning" aria-hidden="true"></span>
        <span>There are saved files in this collection's <b>Dropbox</b> that will be deleted when this collection is deleted.</span>
      </div>
    <% end %>

    <% if @collection.media_objects.count == 0 or @candidates.count > 0 %>
      <div class="alert alert-danger">
        <span class="fa fa-warning" aria-hidden="true"></span>
        <span>Are you certain you want to remove the collection <b><%=@collection.name%></b>?</span>
      </div>

      <%= bootstrap_form_for @collection, method: :delete do |f| %>
      <% if @objects.count > 0 %>

      <h2>Reassign Existing Items</h2>
      <p>
        <b><%=@collection.name%></b> currently contains <%=item_count%>. Before you can
        delete it, you must select a new collection to move <%=content_pronoun%>
        into.
      </p>
      <div class="form-group">
        <%= select_tag :target_collection_id, options_from_collection_for_select(@candidates, "id", "name"), class: "form-control" %>
      </div>
    <% end %>

    <div class="form-group">
      <%= f.submit 'Yes, I am sure', class: 'btn btn-danger' %>
      <%= link_to 'No, go back', admin_collections_path, class: 'btn btn-outline' %>
    </div>
    <% end %>
    <% else %>
    <div class="alert alert-danger">
      The collection "<%=@collection.name%>" cannot be deleted. It contains <%=item_count%>,
      but you do not have sufficient rights to any other collections to reassign <%=content_pronoun%>.
    </div>
    <%= link_to 'Go back', :back, class: 'btn btn-primary' %>
    <% end %>
  </div>
</div>

app/views/admin/collections/show.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% @page_title = t('collections.show.title', :collection_name => @collection.name, :application_name => application_name) %>

<div class="page-title-wrapper">
  <h1 class="page-title">Manage Content</h1>
</div>
<div class="modal fade" id="modal" data-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="modalLabel"
  aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="modalLabel">Crop the image</h1>
      </div>
      <div class="modal-body">
        <div class="img-container">
          <img id="image" src="" style="max-width: 100%;">
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-outline" data-dismiss="modal" id="crop-cancel">Cancel</button>
        <button type="button" class="btn btn-primary" id="crop">Upload</button>
      </div>
    </div>
  </div>
</div>
<div class="admin-collection-details mb-2">
  <h2><%= @collection.name %></h2>
  <div class="row">
    <div class="col-md-9">
      <p><strong>Unit:</strong></p>
      <p><%= @collection.unit %></p>
      <p><strong>Description:</strong></p>
      <p class="collection-description"><%= @collection.description %></p>
      <% if @collection.contact_email.present? %>
        <p><strong>Contact email:</strong></p>
        <p><%= mail_to(@collection.contact_email) %></p>
      <% end %>
      <% if @collection.website_url.present? %>
        <p><strong>Website:</strong></p>
        <p><%= link_to(@collection.website_label.presence || @collection.website_url, @collection.website_url)%></p>
      <% end %>
    </div>
    <div class="col-md-3">
      <p><strong>Poster:</strong></p>
      <p id="poster_original_name"><%= @collection.poster.original_name if @collection.poster.present? %></p>
      <div class="well-vertical-spacer">
        <% if @collection.poster.present? %>
        <%= image_tag(poster_admin_collection_path(@collection), class: 'img-fluid', id: 'poster-image') %>
        <% else %>
        <img src="" class="img-fluid" id="poster-image">
        <% end %>
      </div>
      <div class="row">
        <%= form_for @collection, url: attach_poster_admin_collection_path(@collection.id), html: {method: "post"} do |form| %>
          <%= form.file_field :poster, id: 'poster_input', class: "filedata", style: "height:0px;width:0px;" %>
          <input type="button" class="btn btn-primary btn-sm mr-2" onclick="$('.filedata').click();" value="<% if @collection.poster.present? %>Change Poster<%else%>Upload Poster<%end%>"
            <% if cannot?(:edit, @collection) %>disabled<%end%> />
        <% end %>
        <%= form_for @collection, url: remove_poster_admin_collection_path(@collection.id), html: {method: "delete"} do |form| %>
          <input type="submit" class="btn btn-danger btn-sm" value="Remove Poster" <% if @collection.poster.blank? || cannot?(:edit, @collection) %>disabled<%end%> />
        <% end %>
      </div>
      <div class="well-vertical-spacer">
        <div id='cropper-alert' class="alert" role="alert" style="display: none; padding: 5px; margin-top: 5px"></div>
        <div id="cropper-progress" class="progress" style="display: none; margin-top: 7px;">
          <div id="cropper-progress-bar" class="progress-bar progress-bar-striped progress-bar-animated"
            role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100">0%</div>
        </div>
      </div>
    </div>
  </div>
  <div class="well-vertical-spacer">
    <%= link_to('Create An Item', new_media_object_path(collection_id: @collection.id), class: 'btn btn-primary') if can? :create, MediaObject %>
    <%= link_to('List All Items', search_catalog_path('f[collection_ssim][]' => @collection.name), class: 'btn btn-outline') %>
    <%= button_tag('Edit Collection Info', class: 'btn btn-outline', data: {toggle:"modal", target:"#new_collection"}) if can? :update, @collection %>
  </div>
  <div>
    <p>Or <a
        href='https://samvera.atlassian.net/wiki/spaces/AVALON/pages/1957954666/Avalon+Collections+Guide#AvalonCollectionsGuide-UploadingviaBatch'><b>learn
          how to</b></a> create items using batch upload.</p>
  </div>
</div><!-- /well -->

<div class="card">
  <div class="card-header">
    <h3 class="card-title">Assign Staff Roles</h3>
  </div>
  <div class="card-body">
    <div class='staff-roles-section'>
      <%= render "modules/access_object",
            access_object: "manager",
            members: @collection.managers,
            autocomplete_model: 'user',
            object: @collection,
            input_disabled: cannot?( :update_managers, @collection ) %>
      <%= render "modules/access_object",
            access_object: "editor",
            members: @collection.editors,
            autocomplete_model: 'user',
            object: @collection,
            input_disabled: cannot?( :update_editors, @collection ) %>
      <%= render "modules/access_object",
            access_object: "depositor",
            members: @collection.depositors,
            autocomplete_model: 'user',
            object: @collection,
            input_disabled: cannot?( :update_depositors, @collection ) %>
    </div>
  </div>
</div>

<div class="content-block" style="padding-top: 2rem;">
  <%= render "cdl_form", { object: @collection,
                           lending_period: @collection.default_lending_period,
                           cdl: @collection.cdl_enabled } %>

  <h3 style="padding-top: 3rem;">Set Default Access Control for New Items</h3>
  <%= render "discovery_visibility_form", { object: @collection,
                                            visibility: @collection.default_visibility,
                                            hidden: @collection.default_hidden } %>

  <%= render "modules/special_access", { object: @collection,
                                         modal: { partial: "apply_special_access",
                                                  title: "Apply current Special Access settings to all existing Items" } } %>

</div>

<%= render "form", modal_title: "Edit Collection Information" %>

<% content_for :page_scripts do %>
<script>
  window.addEventListener('DOMContentLoaded', function () {
    add_cropper_handler('<%= attach_poster_admin_collection_path(@collection.id) %>');
  });
</script>
<% end %>